// Xe[gʊǗ
var State = function(globalObj, debugLvl){
	this.debugLvl = (typeof(debugLvl) == "undefined" ? 1 : debugLvl);

	// Error Check
	if(
			arguments.length	< 1
		||	typeof(globalObj)	== "undefined"
	){
		if(this.debugLvl >= 1){ alert("Invalid parameter. => ["+ arguments.length + " : " + typeof(globalObj) + "]"); }
		throw -1;
	}

	this.window = null;
	this.state = null;
	this.stateOld = null;
	this.jumpTo = null;
	this.globalObj = globalObj;
	this.screenTypeDir = globalObj.screenTypeDir;

	// WidgetIuWFNg̃CxgnhStateIuWFNgŃbv
	// => thisœnLVJXR[vŕێ悤A֐ƃN[WŎ
	widget.onmaximize = (function(){
		var this_ = arguments[0];
	
		return function(){
			if(false == this_._commonHandler("maximize")){ return; }
			this_.onmaximize();
		};
	})(this);

	widget.onrestore = (function(){
		var this_ = arguments[0];
	
		return function(){
			if(false == this_._commonHandler("restore")){ return; }
			this_.onrestore();
		};
	})(this);

	widget.ondock = (function(){
		var this_ = arguments[0];
	
		return function(){
			if(false == this_._commonHandler("dock")){ return; }
			this_.ondock();
		};
	})(this);
}

State.prototype = {
	// public\bh /////////////////////////////////////////////
	//      //
	 init : function(stateTree, defaultStateTree, buttonTree){
		// Error Check
		if(
				arguments.length > 3
			||	typeof(stateTree) == "undefined"
			||	typeof(defaultStateTree) == "undefined"
		){
			this.globalObj.errorMsg(this.debugLvl, "Invalid parameter. => ["+ arguments.length + " : " + typeof(stateTree) + " : " + typeof(defaultStateTree) + "]");
			throw -1;
		}

		this.stateTree			= stateTree;
		this.defaultStateTree	= defaultStateTree;
		this.buttonTree			= (typeof(buttonTree) == "undefined") ? {} : buttonTree;

		with({
				 temp		: null
				,elemsAry	: null
				,buttonHash	: null
				,count		: 0
				,i			: 0
		}){
			for(temp in this.defaultStateTree){
				switch(temp){
				case "restore":
					this.state = this.defaultStateTree[temp];

				case "maximize":
				case "dock":
					++count;
					break;

				default:
					this.globalObj.errorMsg(this.debugLvl, "stateDispName[" + temp + "] is invalid.");
					throw -1;
				}
			}
			if(count!=3){
				this.globalObj.errorMsg(this.debugLvl, "defaultStateTree must have 3 members. => [" + count + "]");
				throw -1;
			}

			for(temp in this.stateTree){
				this.stateTree[temp].elem = this.globalObj.getElement(this.stateTree[temp].elemId, true);
			}

			for(temp in this.buttonTree){
				buttonHash = this.buttonTree[temp];
				elemsAry = buttonHash.elems;

				for(i=0; i<elemsAry.length; ++i){
					elemsAry[i].elem = this.globalObj.getElement(elemsAry[i].elemId, true);

					if(elemsAry[i].elemLinkId){
						elemsAry[i].elemLink = this.globalObj.getElement(elemsAry[i].elemLinkId, true);
					}
				}

				// restoreAmaximizeAdocḱAȗ\ɂ
				if(typeof(buttonHash.func) == "undefined"){
					switch(temp){
					case "restore":
						buttonHash.func = function(){ widget.restore(); };
						break;

					case "maximize":
						buttonHash.func = function(){ widget.maximize(); };
						break;

					case "dock":
						buttonHash.func = function(){ widget.dock(); };
						break;

					default:
						this.globalObj.errorMsg(this.debugLvl, "stateDispName[" + temp + "]'s func is not defined.");
						throw -1;
					}
				}
				// ֐񂾂֐IuWFNgɕϊ
				else if(typeof(buttonHash.func) == "string"){
					buttonHash.func = Function(buttonHash.func);
				}

				this._setButton(buttonHash);
			}
		}
	}

	//   Cxgnh   //
	//     OI[o[ChĂB
	,onmaximize : function(){}
	,onrestore  : function(){}
	,ondock     : function(){}

	//   StateύX   //
	,changeState : function(jumpTo){
		// Auto Variables
		var jumpWindowName  = this.stateTree[jumpTo].window;

		// ̒l_commonHandlerŐ䂳
		this.jumpTo = jumpTo;

		if(this.window != jumpWindowName){
			// K؂ȕ\ԂɑJڂŁACxgnhĂ΂悤ɂ
			// => \ԕύX̃\bhĂяo
			switch(jumpWindowName){
			case "restore":
				widget.restore();
				break;

			case "maximize":
				widget.maximize();
				break;

			default:
				widget.dock();
				break;
			}
		}
		else{
			// ύX̃Xe[gƕ\ԂȂ̂ŃV[gJbg
			// => Cxgnh𒼐ڌĂяo
			this.globalObj.infoMsg(this.debugLvl, "same window");

			switch(jumpWindowName){
			case "restore":
				widget.onrestore();
				break;

			case "maximize":
				widget.onmaximize();
				break;

			default:
				widget.ondock();
				break;
			}
		}
	}

	//   OStateɖ߂   //
	,backState : function(){
		if(!this.stateOld){
			this.globalObj.errorMsg(this.debugLvl, "Previous statelDispName is not found.");
			throw -1;
		}
		this.changeState(this.stateOld);
	}

	// private\bh //////////////////////////////////////////////
	,_setButton : function(buttonHash){
		// Auto Variables
		var screenTypeDir = this.screenTypeDir;
		var regImagePath = screenTypeDir + buttonHash.images.reg;
		var regFunc  = function(){ this.src = regImagePath; };
		var overFunc = function(){ this.src = screenTypeDir + buttonHash.images.over; };
		var hitFunc  = function(){ this.src = screenTypeDir + buttonHash.images.hit; };
		var elemsAry = buttonHash.elems;

		// ȉA{^̐U镑ݒ肵Ă
		for(i=0; i<elemsAry.length; ++i){
			elemsAry[i].elem.src = regImagePath;
			this.globalObj.infoMsg(this.debugLvl, regImagePath);

			if(elemsAry[i].elemLink){
				elemsAry[i].elemLink.onfocus	= overFunc;
				elemsAry[i].elemLink.onblur		= regFunc;
				elemsAry[i].elemLink.onclick	= buttonHash.func;
			}
			else{
				elemsAry[i].elem.onfocus		= overFunc;
				elemsAry[i].elem.onblur			= regFunc;
				elemsAry[i].elem.onclick		= buttonHash.func;
			}

			elemsAry[i].elem.onmousedown	= hitFunc;
			elemsAry[i].elem.onmouseup		= regFunc;
			elemsAry[i].elem.onmouseover	= overFunc;
			elemsAry[i].elem.onmouseout		= regFunc;
		}
	}

	,_commonHandler : function(window){
		// Auto Variables
		var tempStateStr = null;
		var tempWindowStr = null;

		this.window = window;

		if(this.jumpTo){
			// w肳ꂽXe[gʂɑJ
			this._changeState(this.jumpTo);
			this.jumpTo = null;
		}
		else{
			tempStateStr = this.defaultStateTree[this.window];
			tempWindowStr = this.stateTree[tempStateStr].window;

			if(tempWindowStr == this.window){
				// ̕\Ԃ̃ftHgXe[gʂɑJ
				this._changeState(tempStateStr);
			}
			else{
				// ftHgɐݒ肳ꂽXe[gʂ́A̕\ԂŃT|[gȂ
				// => \ԕύX
				switch(tempWindowStr){
				case "restore":
					widget.restore();
					break;

				case "maximize":
					widget.maximize();
					break;

				default:
					widget.dock();
					break;
				}

				return false;
			}
		}

		return true;
	}

	,_changeState : function(state){
		this.stateOld = this.state;
		this.state = state;

		// Auto Variables
		var stateHash = this.stateTree[this.state];
		var buttonHash = this.buttonTree[stateHash.window];
		var elemsAry = null;
		var tempStateStr;
		var tempStateHash = null;
		var tempButtonHash = null;
		var tempElemsAry = null;

		// w肳ꂽXe[gʂdisplayݒ
		stateHash.elem.style.display	= 'block';
		if(buttonHash){
			elemsAry = buttonHash.elems;
			for(i=0; i<elemsAry.length; ++i){
				elemsAry[i].elem.style.display	= 'none';
				if(elemsAry[i].elemLink){
					elemsAry[i].elemLink.style.display	= 'none';
				}
			}
		}

		// w肳ꂽXe[gʈȊOdisplayݒ
		// AAw肳ꂽXe[gʂelementƓ̂noneɂȂ
		for(tempStateStr in this.stateTree){
			tempStateHash = this.stateTree[tempStateStr];
			tempButtonHash = this.buttonTree[tempStateHash.window];

			if(tempStateStr != this.state){
				if(stateHash.elem != tempStateHash.elem){
//					alert("disp:"+tempStateStr);
					tempStateHash.elem.style.display	= 'none';
				}

				if(tempButtonHash){
					tempElemsAry = tempButtonHash.elems;

					if(
							buttonHash
						&&	elemsAry != tempElemsAry
					){
						for(i=0; i<tempElemsAry.length; ++i){
		//					alert("button:"+tempStateStr);
							tempElemsAry[i].elem.style.display	= 'block';
							if(tempElemsAry[i].elemLink){
								tempElemsAry[i].elemLink.style.display	= 'block';
							}
						}
					}
				}
			}
		}
	}
}

